Index: /trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Buffers.asm
===================================================================
--- /trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Buffers.asm	(revision 143)
+++ /trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Buffers.asm	(revision 144)
@@ -83,4 +83,5 @@
 	shr		dx, 1
 	rcr		cx, 1
+	adc		cx, BYTE 0		; Round up to next WORD
 	mov		[cs:g_cfgVars+CFGVARS.wImageSizeInWords], cx
 	ret
Index: /trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Menupages/BootMenuSettingsMenu.asm
===================================================================
--- /trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Menupages/BootMenuSettingsMenu.asm	(revision 143)
+++ /trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Menupages/BootMenuSettingsMenu.asm	(revision 144)
@@ -10,5 +10,5 @@
 	at	MENUPAGE.fnEnter,			dw	BootMenuSettingsMenu_EnterMenuOrModifyItemVisibility
 	at	MENUPAGE.fnBack,			dw	ConfigurationMenu_EnterMenuOrModifyItemVisibility
-	at	MENUPAGE.wMenuitems,		dw	5
+	at	MENUPAGE.wMenuitems,		dw	6
 iend
 
@@ -36,4 +36,20 @@
 	at	MENUITEM.itemValue + ITEM_VALUE.wMinValue,					dw	0
 	at	MENUITEM.itemValue + ITEM_VALUE.wMaxValue,					dw	0FFh
+iend
+
+g_MenuitemBootMnuStngsDisplayMode:
+istruc MENUITEM
+	at	MENUITEM.fnActivate,		dw	Menuitem_ActivateMultichoiceSelectionForMenuitemInDSSI
+	at	MENUITEM.fnFormatValue,		dw	MenuitemPrint_WriteLookupValueStringToBufferInESDIfromUnshiftedItemInDSSI
+	at	MENUITEM.szName,			dw	g_szItemBootDispMode
+	at	MENUITEM.szQuickInfo,		dw	g_szNfoDispMode
+	at	MENUITEM.szHelp,			dw	g_szNfoDispMode
+	at	MENUITEM.bFlags,			db	FLG_MENUITEM_VISIBLE
+	at	MENUITEM.bType,				db	TYPE_MENUITEM_MULTICHOICE
+	at	MENUITEM.itemValue + ITEM_VALUE.wRomvarsValueOffset,		dw	ROMVARS.wDisplayMode
+	at	MENUITEM.itemValue + ITEM_VALUE.szDialogTitle,				dw	g_szDlgBootDispMode
+	at	MENUITEM.itemValue + ITEM_VALUE.szMultichoice,				dw	g_szMultichoiceBootDispMode
+	at	MENUITEM.itemValue + ITEM_VALUE.rgwChoiceToValueLookup,		dw	g_rgwChoiceToValueLookupForDisplayModes
+	at	MENUITEM.itemValue + ITEM_VALUE.rgszValueToStringLookup,	dw	g_rgszValueToStringLookupForDisplayModes
 iend
 
@@ -85,4 +101,21 @@
 iend
 
+g_rgwChoiceToValueLookupForDisplayModes:
+	dw	DEFAULT_TEXT_MODE
+	dw	CGA_TEXT_MODE_BW40
+	dw	CGA_TEXT_MODE_CO40
+	dw	CGA_TEXT_MODE_BW80
+	dw	CGA_TEXT_MODE_CO80
+	dw	MDA_TEXT_MODE
+g_rgszValueToStringLookupForDisplayModes:
+	dw	g_szValueBootDispModeBW40
+	dw	g_szValueBootDispModeCO40
+	dw	g_szValueBootDispModeBW80
+	dw	g_szValueBootDispModeCO80
+	dw	g_szValueBootDispModeDefault
+	dw	NULL
+	dw	NULL
+	dw	g_szValueBootDispModeMono
+
 g_rgwChoiceToValueLookupForFloppyDrives:	; (No translation)
 	dw	0
Index: /trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Strings.asm
===================================================================
--- /trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Strings.asm	(revision 143)
+++ /trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Strings.asm	(revision 144)
@@ -177,4 +177,5 @@
 g_szItemBootTimeout:	db	"Selection timeout",NULL
 g_szItemBootDrive:		db	"Default boot drive",NULL
+g_szItemBootDispMode:	db	"Display Mode",NULL
 g_szItemBootFloppyDrvs:	db	"Number of Floppy Drives",NULL
 g_szItemBootSwap:		db	"Swap boot drive numbers",NULL
@@ -182,9 +183,11 @@
 g_szDlgBootTimeout:		db	"Enter Boot Menu selection timeout in BIOS timer ticks (1...1092, 0 disables timeout).",NULL
 g_szDlgBootDrive:		db	"Enter default drive number (0xh for Floppy Drives, 8xh for Hard Disks, FFh for ROM boot).",NULL
-g_szDlgBootFloppyDrvs:	db	"Enter number of Floppy Drives to display on boot menu.",NULL
+g_szDlgBootDispMode:	db	"Select display mode for Boot Menu.",NULL
+g_szDlgBootFloppyDrvs:	db	"Select number of Floppy Drives to display on boot menu.",NULL
 g_szDlgBootSwap:		db	"Enable drive number translation?",NULL
 
 g_szNfoBootTimeout:		db	"Menu item selection timeout in BIOS timer ticks.",NULL
 g_szNfoBootDrive:		db	"Default drive on boot menu.",NULL
+g_szNfoDispMode:		db	"Display Mode for Boot Menu.",NULL
 g_szNfoBootFloppyDrvs:	db	"Number of Floppy Drives to display on boot menu.",NULL
 g_szNfoBootSwap:		db	"Drive Number Translation (swap first drive with selected).",NULL
@@ -198,4 +201,12 @@
 g_szHelpBootSwap:		incbin	"Bootmenu_SwapDrives.txt"
 						db	NULL
+
+g_szMultichoiceBootDispMode:
+						db	"Default",LF
+						db	"40x25 Black & White",LF
+						db	"40x25 Color",LF
+						db	"80x25 Black & White",LF
+						db	"80x25 Color",LF
+						db	"80x25 Monochrome",NULL
 
 g_szMultichoiceBootFloppyDrvs:
@@ -205,4 +216,11 @@
 						db	"3",LF
 						db	"4",NULL
+
+g_szValueBootDispModeDefault:	db	"Default",NULL
+g_szValueBootDispModeBW40:		db	"BW40",NULL
+g_szValueBootDispModeCO40:		db	"CO40",NULL
+g_szValueBootDispModeBW80:		db	"BW80",NULL
+g_szValueBootDispModeCO80:		db	"CO80",NULL
+g_szValueBootDispModeMono:		db	"Mono",NULL
 
 g_szValueBootFloppyDrvsAuto:	db	"Auto",NULL