Index: trunk/XTIDE_Universal_BIOS_Configurator_v2/Inc/Variables.inc
===================================================================
--- trunk/XTIDE_Universal_BIOS_Configurator_v2/Inc/Variables.inc	(revision 145)
+++ trunk/XTIDE_Universal_BIOS_Configurator_v2/Inc/Variables.inc	(revision 153)
@@ -6,4 +6,5 @@
 ; Equates and defines
 MAX_ALLOWED_IDE_CONTROLLERS			EQU		4	; Maximum number of IDE controllers
+MAX_LITE_MODE_CONTROLLERS			EQU		2
 EEPROM_POLLING_TIMEOUT_TICKS		EQU		3	; 1 tick = 54.9 ms
 XTIDE_SIGNATURE_LENGTH				EQU		8	; XTIDE Universal BIOS signature string length
Index: trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Main.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Main.asm	(revision 145)
+++ trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Main.asm	(revision 153)
@@ -1,4 +1,4 @@
 ; Project name	:	XTIDE Univeral BIOS Configurator v2
-; Description	:	Program start and exit.			
+; Description	:	Program start and exit.
 
 ; Include .inc files
Index: trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Menupages/ConfigurationMenu.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Menupages/ConfigurationMenu.asm	(revision 145)
+++ trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Menupages/ConfigurationMenu.asm	(revision 153)
@@ -234,7 +234,8 @@
 	test	ax, FLG_ROMVARS_FULLMODE
 	jnz		SHORT .EnableMenuitemFromCSBX
-.LimitIdeControllerCountToOneForLiteMode:
+
+	; Limit controller count for lite mode
 	call	Buffers_GetFileBufferToESDI
-	mov		BYTE [es:di+ROMVARS.bIdeCnt], 1
+	mov		BYTE [es:di+ROMVARS.bIdeCnt], MAX_LITE_MODE_CONTROLLERS
 	jmp		SHORT .DisableMenuitemFromCSBX
 
Index: trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Menupages/IdeControllerMenu.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Menupages/IdeControllerMenu.asm	(revision 145)
+++ trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Menupages/IdeControllerMenu.asm	(revision 153)
@@ -43,18 +43,18 @@
 iend
 
-g_MenuitemIdeControllerBusType:
+g_MenuitemIdeControllerDevice:
 istruc MENUITEM
 	at	MENUITEM.fnActivate,		dw	Menuitem_ActivateMultichoiceSelectionForMenuitemInDSSI
 	at	MENUITEM.fnFormatValue,		dw	MenuitemPrint_WriteLookupValueStringToBufferInESDIfromShiftedItemInDSSI
-	at	MENUITEM.szName,			dw	g_szItemIdeBusType
-	at	MENUITEM.szQuickInfo,		dw	g_szNfoIdeBusType
-	at	MENUITEM.szHelp,			dw	g_szNfoIdeBusType
+	at	MENUITEM.szName,			dw	g_szItemIdeDevice
+	at	MENUITEM.szQuickInfo,		dw	g_szNfoIdeDevice
+	at	MENUITEM.szHelp,			dw	g_szNfoIdeDevice
 	at	MENUITEM.bFlags,			db	FLG_MENUITEM_VISIBLE | FLG_MENUITEM_BYTEVALUE
 	at	MENUITEM.bType,				db	TYPE_MENUITEM_MULTICHOICE
 	at	MENUITEM.itemValue + ITEM_VALUE.wRomvarsValueOffset,		dw	NULL
-	at	MENUITEM.itemValue + ITEM_VALUE.szDialogTitle,				dw	g_szDlgBusType
-	at	MENUITEM.itemValue + ITEM_VALUE.szMultichoice,				dw	g_szMultichoiceCfgBusType
-	at	MENUITEM.itemValue + ITEM_VALUE.rgwChoiceToValueLookup,		dw	g_rgwChoiceToValueLookupForBusType
-	at	MENUITEM.itemValue + ITEM_VALUE.rgszValueToStringLookup,	dw	g_rgszValueToStringLookupForBusType
+	at	MENUITEM.itemValue + ITEM_VALUE.szDialogTitle,				dw	g_szDlgDevice
+	at	MENUITEM.itemValue + ITEM_VALUE.szMultichoice,				dw	g_szMultichoiceCfgDevice
+	at	MENUITEM.itemValue + ITEM_VALUE.rgwChoiceToValueLookup,		dw	g_rgwChoiceToValueLookupForDevice
+	at	MENUITEM.itemValue + ITEM_VALUE.rgszValueToStringLookup,	dw	g_rgszValueToStringLookupForDevice
 iend
 
@@ -120,14 +120,18 @@
 iend
 
-g_rgwChoiceToValueLookupForBusType:
-	dw	BUS_TYPE_8_DUAL
-	dw	BUS_TYPE_8_SINGLE
-	dw	BUS_TYPE_16
-	dw	BUS_TYPE_32
-g_rgszValueToStringLookupForBusType:
-	dw	g_szValueCfgBusTypeDual8b
-	dw	g_szValueCfgBusType16b
-	dw	g_szValueCfgBusType32b
-	dw	g_szValueCfgBusTypeSingle8b
+g_rgwChoiceToValueLookupForDevice:
+	dw	DEVICE_8BIT_DUAL_PORT_XTIDE
+	dw	DEVICE_XTIDE_WITH_REVERSED_A3_AND_A0
+	dw	DEVICE_8BIT_SINGLE_PORT
+	dw	DEVICE_16BIT_ATA
+	dw	DEVICE_32BIT_ATA
+	dw	DEVICE_SERIAL_PORT
+g_rgszValueToStringLookupForDevice:
+	dw	g_szValueCfgDeviceDual8b
+	dw	g_szValueCfgDeviceMod
+	dw	g_szValueCfgDeviceSingle8b
+	dw	g_szValueCfgDevice16b
+	dw	g_szValueCfgDevice32b
+	dw	g_szValueCfgDeviceSerial
 
 
@@ -152,6 +156,6 @@
 	mov		[cs:g_MenuitemIdeControllerSlaveDrive+MENUITEM.itemValue+ITEM_VALUE.wRomvarsValueOffset], ax
 
-	lea		ax, [bx+IDEVARS.bBusType]
-	mov		[cs:g_MenuitemIdeControllerBusType+MENUITEM.itemValue+ITEM_VALUE.wRomvarsValueOffset], ax
+	lea		ax, [bx+IDEVARS.bDevice]
+	mov		[cs:g_MenuitemIdeControllerDevice+MENUITEM.itemValue+ITEM_VALUE.wRomvarsValueOffset], ax
 
 	lea		ax, [bx+IDEVARS.wPort]
Index: trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Strings.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Strings.asm	(revision 145)
+++ trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Strings.asm	(revision 153)
@@ -88,5 +88,5 @@
 g_szDlgCfgFullMode:		db	"Enable full operating mode?",NULL
 g_szDlgCfgStealSize:	db	"How many kiB of base memory to steal for XTIDE Universal BIOS variables (1...255)?",NULL
-g_szDlgCfgIdeCnt:		db	"How many IDE controllers to manage (1...5)?",NULL
+g_szDlgCfgIdeCnt:		db	"How many IDE controllers to manage (1...4)?",NULL
 
 g_szNfoCfgIde:			db	"IDE controller and drive configuration.",NULL
@@ -106,5 +106,5 @@
 g_szItemIdeMaster:		db	"Master Drive",NULL
 g_szItemIdeSlave:		db	"Slave Drive",NULL
-g_szItemIdeBusType:		db	"Bus type",NULL
+g_szItemIdeDevice:		db	"Device type",NULL
 g_szItemIdeCmdPort:		db	"Base (cmd block) address",NULL
 g_szItemIdeCtrlPort:	db	"Control block address",NULL
@@ -112,5 +112,5 @@
 g_szItemIdeIRQ:			db	"IRQ",NULL
 
-g_szDlgBusType:			db	"Select type of bus where IDE Controller is connected.",NULL
+g_szDlgDevice:			db	"Select controller type.",NULL
 g_szDlgIdeCmdPort:		db	"Enter IDE command block (base port) address.",NULL
 g_szDlgIdeCtrlPort:		db	"Enter IDE control block address (usually command block + 200h).",NULL
@@ -121,5 +121,5 @@
 g_szNfoIdeMaster:		db	"Settings for Master Drive.",NULL
 g_szNfoIdeSlave:		db	"Settings for Slave Drive.",NULL
-g_szNfoIdeBusType:		db	"Select controller bus type.",NULL
+g_szNfoIdeDevice:		db	"Select controller device type.",NULL
 g_szNfoIdeCmdPort:		db	"IDE Controller Command Block (base port) address.",NULL
 g_szNfoIdeCtrlPort:		db	"IDE Controller Control Block address. Usually Cmd Block + 200h.",NULL
@@ -136,14 +136,18 @@
 						db	NULL
 
-g_szMultichoiceCfgBusType:
+g_szMultichoiceCfgDevice:
 						db	"8-bit dual port (XTIDE)",LF
+						db	"XTIDE mod by Chuck(G)",LF
 						db	"8-bit single port",LF
-						db	"16-bit",LF
-						db	"32-bit generic",NULL
-
-g_szValueCfgBusTypeDual8b:		db	"2x8-bit",NULL
-g_szValueCfgBusTypeSingle8b:	db	"1x8-bit",NULL
-g_szValueCfgBusType16b:			db	"16-bit",NULL
-g_szValueCfgBusType32b:			db	"32-bit",NULL
+						db	"16-bit standard IDE",LF
+						db	"32-bit generic IDE",LF
+						db	"Serial port virtual device",NULL
+
+g_szValueCfgDeviceDual8b:	db	"XTIDE",NULL
+g_szValueCfgDeviceMod:		db	"Chuck(G)",NULL
+g_szValueCfgDeviceSingle8b:	db	"8-bit",NULL
+g_szValueCfgDevice16b:		db	"16-bit",NULL
+g_szValueCfgDevice32b:		db	"32-bit",NULL
+g_szValueCfgDeviceSerial:	db	"serial",NULL
 
 