Index: /trunk/Assembly_Library/Inc/Emulate.inc
===================================================================
--- /trunk/Assembly_Library/Inc/Emulate.inc	(revision 161)
+++ /trunk/Assembly_Library/Inc/Emulate.inc	(revision 162)
@@ -376,5 +376,5 @@
 		db	01100101b
 	%else
-		%error "Invalid segment overried passed to eSEG!"
+		%error "Invalid segment override passed to eSEG!"
 	%endif
 %endmacro
Index: /trunk/Assembly_Library/Src/AssemblyLibrary.asm
===================================================================
--- /trunk/Assembly_Library/Src/AssemblyLibrary.asm	(revision 161)
+++ /trunk/Assembly_Library/Src/AssemblyLibrary.asm	(revision 162)
@@ -60,6 +60,6 @@
 	%ifndef EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS
 		%include "String.asm"
+		%include "StringProcess.asm"
 	%endif
-	%include "StringProcess.asm"
 %endif
 
Index: /trunk/Assembly_Library/Src/Display/CgaSnow.asm
===================================================================
--- /trunk/Assembly_Library/Src/Display/CgaSnow.asm	(revision 161)
+++ /trunk/Assembly_Library/Src/Display/CgaSnow.asm	(revision 162)
@@ -31,6 +31,6 @@
 
 
-; CGA snow preventing must be kept optional so unnecerrasy overhead
-; can be prevented when building program ment for non-CGA systems.
+; CGA snow prevention must be kept optional to avoid unnecessary
+; overhead when building programs meant for non-CGA systems.
 %ifdef ELIMINATE_CGA_SNOW
 
@@ -74,6 +74,6 @@
 .StoswWithoutWaitSinceUnknownPort:
 	stosw
+	sti
 	pop		bx
-	sti
 	ret
 
Index: /trunk/Assembly_Library/Src/Display/DisplayContext.asm
===================================================================
--- /trunk/Assembly_Library/Src/Display/DisplayContext.asm	(revision 161)
+++ /trunk/Assembly_Library/Src/Display/DisplayContext.asm	(revision 162)
@@ -268,10 +268,10 @@
 ;		Nothing
 ;--------------------------------------------------------------------
-%ifndef EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS	; This appears to be completely unused
-ALIGN JUMP_ALIGN
-DisplayContext_GetCharacterOutputParameterToDX:
-	mov		dx, [VIDEO_BDA.displayContext+DISPLAY_CONTEXT.wCharOutParam]
-	ret
-%endif
+;%ifndef EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS	; This appears to be completely unused
+;ALIGN JUMP_ALIGN
+;DisplayContext_GetCharacterOutputParameterToDX:
+;	mov		dx, [VIDEO_BDA.displayContext+DISPLAY_CONTEXT.wCharOutParam]
+;	ret
+;%endif
 
 
Index: /trunk/Assembly_Library/Src/Display/DisplayPrint.asm
===================================================================
--- /trunk/Assembly_Library/Src/Display/DisplayPrint.asm	(revision 161)
+++ /trunk/Assembly_Library/Src/Display/DisplayPrint.asm	(revision 162)
@@ -25,5 +25,5 @@
 ;	For example %8-d would prepend integer with spaces so that at least
 ;	8 characters would be printed.
-; 
+;
 ; DisplayPrint_FormattedNullTerminatedStringFromCSSI
 ;	Parameters:
@@ -158,5 +158,5 @@
 	loop	.PrintNextCharacter
 
-	LOAD_BDA_SEGMENT_TO	ds, dx
+	mov		ds, cx	; Restore DS to BDA. Not needed unless DisplayPrint_CharacterFromAL changes DS.
 	pop		cx
 	pop		si
Index: /trunk/Assembly_Library/Src/Menu/Dialog/Dialog.asm
===================================================================
--- /trunk/Assembly_Library/Src/Menu/Dialog/Dialog.asm	(revision 161)
+++ /trunk/Assembly_Library/Src/Menu/Dialog/Dialog.asm	(revision 162)
@@ -1,7 +1,3 @@
-; File name		:	Dialog.asm
 ; Project name	:	Assembly Library
-; Created date	:	6.8.2010
-; Last update	:	22.11.2010
-; Author		:	Tomi Tilli
 ; Description	:	Common functions for many dialogs.
 
@@ -235,25 +231,6 @@
 	call	MenuLocation_GetTitleBordersTopLeftCoordinatesToAX
 	cmp		ah, dh		; Dialog taller than parent?
-	jb		SHORT .RedrawDialogAreaAndWholeParentWindow
-	jmp		SHORT .RedrawWholeParentWindow
-
-;--------------------------------------------------------------------
-; .GetParentTitleBorderCoordinatesToDX
-;	Parameters:
-;		SS:SI:	Ptr to parent MENU
-;		SS:BP:	Ptr to DIALOG
-;	Returns:
-;		DL:		Parent border column (X)
-;		DH:		Parent border row (Y)
-;	Corrupts:
-;		AX
-;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
-.GetParentTitleBorderCoordinatesToDX:
-	xchg	si, bp
-	call	MenuLocation_GetTitleBordersTopLeftCoordinatesToAX
-	xchg	bp, si
-	xchg	dx, ax
-	ret
+	jnb		SHORT .RedrawWholeParentWindow
+	; Fall to .RedrawDialogAreaAndWholeParentWindow
 
 ;--------------------------------------------------------------------
@@ -268,5 +245,4 @@
 ;		AX, BX, CX, DX, SI, DI
 ;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
 .RedrawDialogAreaAndWholeParentWindow:
 	push	si
@@ -286,2 +262,21 @@
 	pop		bp
 	ret
+
+;--------------------------------------------------------------------
+; .GetParentTitleBorderCoordinatesToDX
+;	Parameters:
+;		SS:SI:	Ptr to parent MENU
+;		SS:BP:	Ptr to DIALOG
+;	Returns:
+;		DL:		Parent border column (X)
+;		DH:		Parent border row (Y)
+;	Corrupts:
+;		AX
+;--------------------------------------------------------------------
+ALIGN JUMP_ALIGN
+.GetParentTitleBorderCoordinatesToDX:
+	xchg	si, bp
+	call	MenuLocation_GetTitleBordersTopLeftCoordinatesToAX
+	xchg	bp, si
+	xchg	dx, ax
+	ret
Index: /trunk/Assembly_Library/Src/String/Char.asm
===================================================================
--- /trunk/Assembly_Library/Src/String/Char.asm	(revision 161)
+++ /trunk/Assembly_Library/Src/String/Char.asm	(revision 162)
@@ -1,7 +1,3 @@
-; File name		:	Char.asm
 ; Project name	:	Assembly Library
-; Created date	:	28.6.2010
-; Last update	:	7.9.2010
-; Author		:	Tomi Tilli
 ; Description	:	Functions for handling characters.
 
@@ -18,5 +14,5 @@
 ;	Returns:
 ;		CF:		Set if character is range
-;				(Jumps to CharIsNotValid if before range)
+;				(Jumps to Char_CharIsNotValid if before range)
 ;	Corrupts registers:
 ;		Nothing
@@ -24,5 +20,5 @@
 %macro IS_BETWEEN_IMMEDIATES 3
 	cmp		%1, %2
-	jb		SHORT CharIsNotValid
+	jb		SHORT Char_CharIsNotValid
 	cmp		%1, (%3)+1				; Set CF if %1 is lesser
 %endmacro
@@ -54,8 +50,10 @@
 ;		Nothing
 ;--------------------------------------------------------------------
+%ifndef EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS
 ALIGN JUMP_ALIGN
 Char_IsUpperCaseLetterInAL:
 	IS_BETWEEN_IMMEDIATES al, 'A', 'Z'
 	ret
+%endif
 
 ;--------------------------------------------------------------------
@@ -70,4 +68,5 @@
 ;		Nothing
 ;--------------------------------------------------------------------
+%ifndef EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS
 ALIGN JUMP_ALIGN
 Char_IsHexadecimalDigitInAL:
@@ -77,4 +76,5 @@
 	IS_BETWEEN_IMMEDIATES al, 'a', 'f'
 	ret
+%endif
 
 ;--------------------------------------------------------------------
@@ -106,4 +106,5 @@
 ;		Nothing
 ;--------------------------------------------------------------------
+%ifndef EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS
 ALIGN JUMP_ALIGN
 Char_ConvertIntegerToALfromDigitInALwithBaseInBX:
@@ -112,5 +113,5 @@
 	call	dx						; Converts to lower case
 	pop		dx
-	jnc		SHORT CharIsNotValid
+	jnc		SHORT Char_CharIsNotValid
 
 	cmp		al, '9'					; Decimal digit
@@ -120,24 +121,27 @@
 .ConvertToDecimalDigit:
 	sub		al, '0'					; Convert to decimal integer
-	; Fall to CharIsValid
-
-;--------------------------------------------------------------------
-; CharIsValid
-; CharIsNotValid
-;	Parameters:
-;		Nothing
-;	Returns:
-;		CF:		Set for CharIsValid
-;				Cleared for CharIsNotValid
-;	Corrupts registers:
-;		Nothing
-;--------------------------------------------------------------------
+	; Fall to Char_CharIsValid
+%endif
+
+;--------------------------------------------------------------------
+; Char_CharIsValid
+; Char_CharIsNotValid
+;	Parameters:
+;		Nothing
+;	Returns:
+;		CF:		Set for Char_CharIsValid
+;				Cleared for Char_CharIsNotValid
+;	Corrupts registers:
+;		Nothing
+;--------------------------------------------------------------------
+%ifndef EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS
 ALIGN JUMP_ALIGN
 Char_CharIsValid:
 	stc
 	ret
-
-ALIGN JUMP_ALIGN
-CharIsNotValid:
+%endif
+
+ALIGN JUMP_ALIGN
+Char_CharIsNotValid:
 	clc
 	ret
@@ -153,4 +157,5 @@
 ;		Nothing
 ;--------------------------------------------------------------------
+%ifndef EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS
 ALIGN JUMP_ALIGN
 Char_ALtoLowerCaseLetter:
@@ -160,4 +165,5 @@
 .Return:
 	ret
+%endif
 
 ;--------------------------------------------------------------------
@@ -188,4 +194,5 @@
 ;		Nothing
 ;--------------------------------------------------------------------
+%ifndef EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS
 ALIGN JUMP_ALIGN
 Char_GetFilterFunctionToDXforNumericBaseInBX:
@@ -193,5 +200,6 @@
 	cmp		bl, 10
 	je		SHORT .Return
-	sub		dx, BYTE Char_IsDecimalDigitInAL - Char_IsHexadecimalDigitInAL
+	mov		dx, Char_IsHexadecimalDigitInAL
 .Return:
 	ret
+%endif
Index: /trunk/Assembly_Library/Src/String/StringProcess.asm
===================================================================
--- /trunk/Assembly_Library/Src/String/StringProcess.asm	(revision 161)
+++ /trunk/Assembly_Library/Src/String/StringProcess.asm	(revision 162)
@@ -1,7 +1,3 @@
-; File name		:	StringProcess.asm
 ; Project name	:	Assembly Library
-; Created date	:	12.10.2010
-; Last update	:	7.12.2010
-; Author		:	Tomi Tilli
 ; Description	:	Functions for processing characters in a string.
 
@@ -33,5 +29,5 @@
 ;		CX:		Number of characters processed
 ;		CF:		Clear if all characters processed
-;				Set if terminated by processing function				
+;				Set if terminated by processing function
 ;	Corrupts registers:
 ;		Nothing (processing function can corrupt BX,DI,ES)
@@ -91,5 +87,6 @@
 StringProcess_ConvertToWordInDIWithBaseInBX:
 	call	Char_ConvertIntegerToALfromDigitInALwithBaseInBX
-	jnc		SHORT .InvalidCharacter
+	cmc
+	jc		SHORT .InvalidCharacter
 	push	dx
 
@@ -99,11 +96,7 @@
 	jc		SHORT .Overflow
 	add		di, ax		; Add old WORD to new integer
-	jc		SHORT .Overflow
 
-	pop		dx
-	ret
 .Overflow:
 	pop		dx
 .InvalidCharacter:
-	stc					; Set CF to stop processing
 	ret
Index: /trunk/Configurator/Inc/emulate.inc
===================================================================
--- /trunk/Configurator/Inc/emulate.inc	(revision 161)
+++ /trunk/Configurator/Inc/emulate.inc	(revision 162)
@@ -329,5 +329,5 @@
 		db	01100101b
 	%else
-		%error "Invalid segment overried passed to eSEG!"
+		%error "Invalid segment override passed to eSEG!"
 	%endif
 %endmacro
Index: /trunk/Configurator/Src/Libraries/file.asm
===================================================================
--- /trunk/Configurator/Src/Libraries/file.asm	(revision 161)
+++ /trunk/Configurator/Src/Libraries/file.asm	(revision 162)
@@ -1,8 +1,4 @@
-; File name		:	file.asm
 ; Project name	:	File library
-; Created date	:	19.11.2009
-; Last update	:	24.11.2009
-; Author		:	Tomi Tilli
-; Description	:	ASM library for DOS file handling.	
+; Description	:	ASM library for DOS file handling.
 
 ;--------------- Equates -----------------------------
@@ -69,5 +65,5 @@
 ; Returns pointer to error string.
 ; Pointer is always valid, even if error code is not.
-; 
+;
 ; File_GetErrStr
 ;	Parameters:
@@ -111,5 +107,5 @@
 ; Opens file for reading and writing.
 ; File must be closed with File_Close when no longer needed.
-; 
+;
 ; File_Open
 ;	Parameters:
@@ -137,5 +133,5 @@
 ;--------------------------------------------------------------------
 ; Closes file.
-; 
+;
 ; File_Close
 ;	Parameters:
@@ -159,5 +155,5 @@
 ; File position is updated so next read will start where
 ; previous read stopped.
-; 
+;
 ; File_Read
 ;	Parameters:
@@ -191,5 +187,5 @@
 ; File position is updated so next write will start where
 ; previous write stopped.
-; 
+;
 ; File_Write
 ;	Parameters:
@@ -221,5 +217,5 @@
 ;--------------------------------------------------------------------
 ; Sets current file position to wanted offset.
-; 
+;
 ; File_SetFilePos
 ;	Parameters:
@@ -244,5 +240,5 @@
 ;--------------------------------------------------------------------
 ; Changes current default drive.
-; 
+;
 ; File_SetDrive
 ;	Parameters:
@@ -263,5 +259,5 @@
 ; Returns current default drive and number of
 ; potentially drive letters available.
-; 
+;
 ; File_GetDrive
 ;	Parameters:
@@ -286,7 +282,7 @@
 
 ;--------------------------------------------------------------------
-; Checks are the potentially valid drive letters returned by 
+; Checks are the potentially valid drive letters returned by
 ; File_SetDrive and File_GetDrive actually valid or not.
-; 
+;
 ; File_IsDrive
 ;	Parameters:
@@ -315,5 +311,5 @@
 ;--------------------------------------------------------------------
 ; Returns number of valid drive letters.
-; 
+;
 ; File_GetValidDrvCnt
 ;	Parameters:
@@ -337,5 +333,5 @@
 	inc		dx					; Increment drive number
 	loop	.LetterLoop			; Loop while drive letters left
-	eMOVZX	cx, dh				; Valid drv count to CX
+	mov		cl, dh				; Valid drv count to CX
 	ret
 
@@ -344,5 +340,5 @@
 ; Return device number for Nth valid drive.
 ; This function does not check if index in CX is valid.
-; 
+;
 ; File_GetNthValidDrv
 ;	Parameters:
@@ -353,5 +349,5 @@
 ;	Corrupts registers:
 ;		CX
-;--------------------------------------------------------------------	
+;--------------------------------------------------------------------
 ALIGN JUMP_ALIGN
 File_GetNthValidDrv:
@@ -371,5 +367,5 @@
 ;--------------------------------------------------------------------
 ; Changes current directory.
-; 
+;
 ; File_ChangeDir
 ;	Parameters:
@@ -391,5 +387,5 @@
 ;--------------------------------------------------------------------
 ; Finds files from wanted path using search wildcard characters.
-; 
+;
 ; File_FindAndCount
 ;	Parameters:
@@ -419,5 +415,5 @@
 ; Finds files from wanted path using search wildcard characters.
 ; Ptr to DTA is returned for wanted file.
-; 
+;
 ; File_GetDTA
 ;	Parameters:
@@ -457,5 +453,5 @@
 ;--------------------------------------------------------------------
 ; Find first file or directory.
-; 
+;
 ; File_FindFirst
 ;	Parameters:
@@ -482,5 +478,5 @@
 ; Find next file or directory. File_FindFirst must always be called
 ; before calling File_FindNext.
-; 
+;
 ; File_FindNext
 ;	Parameters:
Index: /trunk/XTIDE_Universal_BIOS/Src/Boot/BootMenuPrint.asm
===================================================================
--- /trunk/XTIDE_Universal_BIOS/Src/Boot/BootMenuPrint.asm	(revision 161)
+++ /trunk/XTIDE_Universal_BIOS/Src/Boot/BootMenuPrint.asm	(revision 162)
@@ -204,5 +204,4 @@
 ;		AX, BX, SI, DI
 ;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
 .PrintKnownFloppyType:
 	mov		si, g_szFddSize
@@ -269,5 +268,4 @@
 ;		AX, BX, CX, DX, SI, DI, ES
 ;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
 .HardDiskMenuitemInfoForOurDrive:
 	push	di
Index: /trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/AH11h_HRecal.asm
===================================================================
--- /trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/AH11h_HRecal.asm	(revision 161)
+++ /trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/AH11h_HRecal.asm	(revision 162)
@@ -24,5 +24,5 @@
 %else
 	push	Int13h_ReturnFromHandlerAfterStoringErrorCodeFromAH
-	; Fall through to AH11h_RecalibrateDrive
+	; Fall to AH11h_RecalibrateDrive
 %endif
 
Index: /trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/AH23h_HFeatures.asm
===================================================================
--- /trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/AH23h_HFeatures.asm	(revision 161)
+++ /trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/AH23h_HFeatures.asm	(revision 162)
@@ -35,5 +35,5 @@
 %else
 	push	Int13h_ReturnFromHandlerAfterStoringErrorCodeFromAH
-	; Fall through to AH23h_SetControllerFeatures
+	; Fall to AH23h_SetControllerFeatures
 %endif
 
Index: /trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/AH24h_HSetBlocks.asm
===================================================================
--- /trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/AH24h_HSetBlocks.asm	(revision 161)
+++ /trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/AH24h_HSetBlocks.asm	(revision 162)
@@ -35,5 +35,5 @@
 %else
 	push	Int13h_ReturnFromHandlerAfterStoringErrorCodeFromAH
-	; Fall through to AH24h_SetBlockSize
+	; Fall to AH24h_SetBlockSize
 %endif
 
Index: /trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/AH9h_HInit.asm
===================================================================
--- /trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/AH9h_HInit.asm	(revision 161)
+++ /trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/AH9h_HInit.asm	(revision 162)
@@ -24,5 +24,5 @@
 %else
 	push	Int13h_ReturnFromHandlerAfterStoringErrorCodeFromAH
-	; Fall through to AH9h_InitializeDriveForUse
+	; Fall to AH9h_InitializeDriveForUse
 %endif
 
Index: /trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/AHCh_HSeek.asm
===================================================================
--- /trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/AHCh_HSeek.asm	(revision 161)
+++ /trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/AHCh_HSeek.asm	(revision 162)
@@ -30,5 +30,5 @@
 %else
 	push	Int13h_ReturnFromHandlerAfterStoringErrorCodeFromAH
-	; Fall through to AHCh_SeekToCylinder
+	; Fall to AHCh_SeekToCylinder
 %endif
 
Index: /trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/AHDh_HReset.asm
===================================================================
--- /trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/AHDh_HReset.asm	(revision 161)
+++ /trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/AHDh_HReset.asm	(revision 162)
@@ -24,5 +24,5 @@
 %else
 	push	Int13h_ReturnFromHandlerAfterStoringErrorCodeFromAH
-	; Fall through to AHDh_ResetDrive
+	; Fall to AHDh_ResetDrive
 %endif
 
Index: /trunk/XTIDE_Universal_BIOS/Src/Initialization/Interrupts.asm
===================================================================
--- /trunk/XTIDE_Universal_BIOS/Src/Initialization/Interrupts.asm	(revision 161)
+++ /trunk/XTIDE_Universal_BIOS/Src/Initialization/Interrupts.asm	(revision 162)
@@ -97,5 +97,5 @@
 	cmp		bl, 8
 	jb		SHORT .InstallLowIrqHandler
-	; Fall through to .InstallHighIrqHandler
+	; Fall to .InstallHighIrqHandler
 
 ;--------------------------------------------------------------------
@@ -164,5 +164,5 @@
 	cmp		al, 8
 	jb		SHORT .UnmaskLowIrqController
-	; Fall through to .UnmaskHighIrqController
+	; Fall to .UnmaskHighIrqController
 
 ;--------------------------------------------------------------------
Index: /trunk/XTIDE_Universal_BIOS/Src/VariablesAndDPTs/CreateDPT.asm
===================================================================
--- /trunk/XTIDE_Universal_BIOS/Src/VariablesAndDPTs/CreateDPT.asm	(revision 161)
+++ /trunk/XTIDE_Universal_BIOS/Src/VariablesAndDPTs/CreateDPT.asm	(revision 162)
@@ -203,6 +203,5 @@
 ;	Returns:
 ;		DL:		Drive number for new drive
-;		CF:		Cleared if DPT parameters stored successfully
-;				Set if any error
+;		CF:		Always cleared
 ;	Corrupts registers:
 ;		Nothing
@@ -218,5 +217,5 @@
 	ja		SHORT .AllDone				;  If so, return
 	mov		[RAMVARS.bFirstDrv], dl		; Store first drive number
+	clc
 .AllDone:
-	clc
 	ret